#ifndef _H_0F6D3FA96F8FE6EA26A6D97EB8D2C098_PrimaryControl_DCPS_H_
#define _H_0F6D3FA96F8FE6EA26A6D97EB8D2C098_PrimaryControl_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PrimaryControl_.h"


namespace marti_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PrimaryControl_TypeSupportInterface;

            typedef PrimaryControl_TypeSupportInterface * PrimaryControl_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PrimaryControl_TypeSupportInterface> PrimaryControl_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PrimaryControl_TypeSupportInterface> PrimaryControl_TypeSupportInterface_out;


            class PrimaryControl_DataWriter;

            typedef PrimaryControl_DataWriter * PrimaryControl_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PrimaryControl_DataWriter> PrimaryControl_DataWriter_var;
            typedef DDS_DCPSInterface_out < PrimaryControl_DataWriter> PrimaryControl_DataWriter_out;


            class PrimaryControl_DataReader;

            typedef PrimaryControl_DataReader * PrimaryControl_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PrimaryControl_DataReader> PrimaryControl_DataReader_var;
            typedef DDS_DCPSInterface_out < PrimaryControl_DataReader> PrimaryControl_DataReader_out;


            class PrimaryControl_DataReaderView;

            typedef PrimaryControl_DataReaderView * PrimaryControl_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PrimaryControl_DataReaderView> PrimaryControl_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PrimaryControl_DataReaderView> PrimaryControl_DataReaderView_out;

            struct PrimaryControl_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PrimaryControl_, struct PrimaryControl_Seq_uniq_> PrimaryControl_Seq;
            typedef DDS_DCPSSequence_var < PrimaryControl_Seq> PrimaryControl_Seq_var;
            typedef DDS_DCPSSequence_out < PrimaryControl_Seq> PrimaryControl_Seq_out;

            class  PrimaryControl_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PrimaryControl_TypeSupportInterface_ptr _ptr_type;
                typedef PrimaryControl_TypeSupportInterface_var _var_type;

                static PrimaryControl_TypeSupportInterface_ptr _duplicate (PrimaryControl_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryControl_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryControl_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryControl_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryControl_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PrimaryControl_TypeSupportInterface () {};
                ~PrimaryControl_TypeSupportInterface () {};
            private:
                PrimaryControl_TypeSupportInterface (const PrimaryControl_TypeSupportInterface &);
                PrimaryControl_TypeSupportInterface & operator = (const PrimaryControl_TypeSupportInterface &);
            };

            class  PrimaryControl_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PrimaryControl_DataWriter_ptr _ptr_type;
                typedef PrimaryControl_DataWriter_var _var_type;

                static PrimaryControl_DataWriter_ptr _duplicate (PrimaryControl_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryControl_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryControl_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryControl_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryControl_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PrimaryControl_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PrimaryControl_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PrimaryControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PrimaryControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PrimaryControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PrimaryControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PrimaryControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PrimaryControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PrimaryControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PrimaryControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PrimaryControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PrimaryControl_& instance_data) = 0;

            protected:
                PrimaryControl_DataWriter () {};
                ~PrimaryControl_DataWriter () {};
            private:
                PrimaryControl_DataWriter (const PrimaryControl_DataWriter &);
                PrimaryControl_DataWriter & operator = (const PrimaryControl_DataWriter &);
            };

            class  PrimaryControl_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PrimaryControl_DataReader_ptr _ptr_type;
                typedef PrimaryControl_DataReader_var _var_type;

                static PrimaryControl_DataReader_ptr _duplicate (PrimaryControl_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryControl_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryControl_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryControl_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryControl_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PrimaryControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PrimaryControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PrimaryControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PrimaryControl_& instance) = 0;

            protected:
                PrimaryControl_DataReader () {};
                ~PrimaryControl_DataReader () {};
            private:
                PrimaryControl_DataReader (const PrimaryControl_DataReader &);
                PrimaryControl_DataReader & operator = (const PrimaryControl_DataReader &);
            };

            class  PrimaryControl_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PrimaryControl_DataReaderView_ptr _ptr_type;
                typedef PrimaryControl_DataReaderView_var _var_type;

                static PrimaryControl_DataReaderView_ptr _duplicate (PrimaryControl_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryControl_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryControl_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryControl_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryControl_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PrimaryControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PrimaryControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PrimaryControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PrimaryControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PrimaryControl_& instance) = 0;

            protected:
                PrimaryControl_DataReaderView () {};
                ~PrimaryControl_DataReaderView () {};
            private:
                PrimaryControl_DataReaderView (const PrimaryControl_DataReaderView &);
                PrimaryControl_DataReaderView & operator = (const PrimaryControl_DataReaderView &);
            };
        }

    }

}

#endif
