#ifndef _H_5588D2A6ADC4FC07503897C486CFDDCD_TransmissionFeedback_DCPS_H_
#define _H_5588D2A6ADC4FC07503897C486CFDDCD_TransmissionFeedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TransmissionFeedback_.h"


namespace marti_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TransmissionFeedback_TypeSupportInterface;

            typedef TransmissionFeedback_TypeSupportInterface * TransmissionFeedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TransmissionFeedback_TypeSupportInterface> TransmissionFeedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TransmissionFeedback_TypeSupportInterface> TransmissionFeedback_TypeSupportInterface_out;


            class TransmissionFeedback_DataWriter;

            typedef TransmissionFeedback_DataWriter * TransmissionFeedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TransmissionFeedback_DataWriter> TransmissionFeedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < TransmissionFeedback_DataWriter> TransmissionFeedback_DataWriter_out;


            class TransmissionFeedback_DataReader;

            typedef TransmissionFeedback_DataReader * TransmissionFeedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TransmissionFeedback_DataReader> TransmissionFeedback_DataReader_var;
            typedef DDS_DCPSInterface_out < TransmissionFeedback_DataReader> TransmissionFeedback_DataReader_out;


            class TransmissionFeedback_DataReaderView;

            typedef TransmissionFeedback_DataReaderView * TransmissionFeedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TransmissionFeedback_DataReaderView> TransmissionFeedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TransmissionFeedback_DataReaderView> TransmissionFeedback_DataReaderView_out;

            struct TransmissionFeedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TransmissionFeedback_, struct TransmissionFeedback_Seq_uniq_> TransmissionFeedback_Seq;
            typedef DDS_DCPSSequence_var < TransmissionFeedback_Seq> TransmissionFeedback_Seq_var;
            typedef DDS_DCPSSequence_out < TransmissionFeedback_Seq> TransmissionFeedback_Seq_out;

            class  TransmissionFeedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TransmissionFeedback_TypeSupportInterface_ptr _ptr_type;
                typedef TransmissionFeedback_TypeSupportInterface_var _var_type;

                static TransmissionFeedback_TypeSupportInterface_ptr _duplicate (TransmissionFeedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransmissionFeedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TransmissionFeedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TransmissionFeedback_TypeSupportInterface () {};
                ~TransmissionFeedback_TypeSupportInterface () {};
            private:
                TransmissionFeedback_TypeSupportInterface (const TransmissionFeedback_TypeSupportInterface &);
                TransmissionFeedback_TypeSupportInterface & operator = (const TransmissionFeedback_TypeSupportInterface &);
            };

            class  TransmissionFeedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TransmissionFeedback_DataWriter_ptr _ptr_type;
                typedef TransmissionFeedback_DataWriter_var _var_type;

                static TransmissionFeedback_DataWriter_ptr _duplicate (TransmissionFeedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransmissionFeedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TransmissionFeedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TransmissionFeedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TransmissionFeedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TransmissionFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TransmissionFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TransmissionFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TransmissionFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TransmissionFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TransmissionFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TransmissionFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TransmissionFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TransmissionFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TransmissionFeedback_& instance_data) = 0;

            protected:
                TransmissionFeedback_DataWriter () {};
                ~TransmissionFeedback_DataWriter () {};
            private:
                TransmissionFeedback_DataWriter (const TransmissionFeedback_DataWriter &);
                TransmissionFeedback_DataWriter & operator = (const TransmissionFeedback_DataWriter &);
            };

            class  TransmissionFeedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TransmissionFeedback_DataReader_ptr _ptr_type;
                typedef TransmissionFeedback_DataReader_var _var_type;

                static TransmissionFeedback_DataReader_ptr _duplicate (TransmissionFeedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransmissionFeedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TransmissionFeedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TransmissionFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TransmissionFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TransmissionFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TransmissionFeedback_& instance) = 0;

            protected:
                TransmissionFeedback_DataReader () {};
                ~TransmissionFeedback_DataReader () {};
            private:
                TransmissionFeedback_DataReader (const TransmissionFeedback_DataReader &);
                TransmissionFeedback_DataReader & operator = (const TransmissionFeedback_DataReader &);
            };

            class  TransmissionFeedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TransmissionFeedback_DataReaderView_ptr _ptr_type;
                typedef TransmissionFeedback_DataReaderView_var _var_type;

                static TransmissionFeedback_DataReaderView_ptr _duplicate (TransmissionFeedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TransmissionFeedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TransmissionFeedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TransmissionFeedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TransmissionFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TransmissionFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TransmissionFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TransmissionFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TransmissionFeedback_& instance) = 0;

            protected:
                TransmissionFeedback_DataReaderView () {};
                ~TransmissionFeedback_DataReaderView () {};
            private:
                TransmissionFeedback_DataReaderView (const TransmissionFeedback_DataReaderView &);
                TransmissionFeedback_DataReaderView & operator = (const TransmissionFeedback_DataReaderView &);
            };
        }

    }

}

#endif
