#ifndef _H_B3C66A1B06274F0C2551D8DF71A569E8_PrimaryFeedback_DCPS_H_
#define _H_B3C66A1B06274F0C2551D8DF71A569E8_PrimaryFeedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PrimaryFeedback_.h"


namespace marti_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PrimaryFeedback_TypeSupportInterface;

            typedef PrimaryFeedback_TypeSupportInterface * PrimaryFeedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PrimaryFeedback_TypeSupportInterface> PrimaryFeedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PrimaryFeedback_TypeSupportInterface> PrimaryFeedback_TypeSupportInterface_out;


            class PrimaryFeedback_DataWriter;

            typedef PrimaryFeedback_DataWriter * PrimaryFeedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PrimaryFeedback_DataWriter> PrimaryFeedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < PrimaryFeedback_DataWriter> PrimaryFeedback_DataWriter_out;


            class PrimaryFeedback_DataReader;

            typedef PrimaryFeedback_DataReader * PrimaryFeedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PrimaryFeedback_DataReader> PrimaryFeedback_DataReader_var;
            typedef DDS_DCPSInterface_out < PrimaryFeedback_DataReader> PrimaryFeedback_DataReader_out;


            class PrimaryFeedback_DataReaderView;

            typedef PrimaryFeedback_DataReaderView * PrimaryFeedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PrimaryFeedback_DataReaderView> PrimaryFeedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PrimaryFeedback_DataReaderView> PrimaryFeedback_DataReaderView_out;

            struct PrimaryFeedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PrimaryFeedback_, struct PrimaryFeedback_Seq_uniq_> PrimaryFeedback_Seq;
            typedef DDS_DCPSSequence_var < PrimaryFeedback_Seq> PrimaryFeedback_Seq_var;
            typedef DDS_DCPSSequence_out < PrimaryFeedback_Seq> PrimaryFeedback_Seq_out;

            class  PrimaryFeedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PrimaryFeedback_TypeSupportInterface_ptr _ptr_type;
                typedef PrimaryFeedback_TypeSupportInterface_var _var_type;

                static PrimaryFeedback_TypeSupportInterface_ptr _duplicate (PrimaryFeedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryFeedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryFeedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PrimaryFeedback_TypeSupportInterface () {};
                ~PrimaryFeedback_TypeSupportInterface () {};
            private:
                PrimaryFeedback_TypeSupportInterface (const PrimaryFeedback_TypeSupportInterface &);
                PrimaryFeedback_TypeSupportInterface & operator = (const PrimaryFeedback_TypeSupportInterface &);
            };

            class  PrimaryFeedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PrimaryFeedback_DataWriter_ptr _ptr_type;
                typedef PrimaryFeedback_DataWriter_var _var_type;

                static PrimaryFeedback_DataWriter_ptr _duplicate (PrimaryFeedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryFeedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryFeedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PrimaryFeedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PrimaryFeedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PrimaryFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PrimaryFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PrimaryFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PrimaryFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PrimaryFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PrimaryFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PrimaryFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PrimaryFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PrimaryFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PrimaryFeedback_& instance_data) = 0;

            protected:
                PrimaryFeedback_DataWriter () {};
                ~PrimaryFeedback_DataWriter () {};
            private:
                PrimaryFeedback_DataWriter (const PrimaryFeedback_DataWriter &);
                PrimaryFeedback_DataWriter & operator = (const PrimaryFeedback_DataWriter &);
            };

            class  PrimaryFeedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PrimaryFeedback_DataReader_ptr _ptr_type;
                typedef PrimaryFeedback_DataReader_var _var_type;

                static PrimaryFeedback_DataReader_ptr _duplicate (PrimaryFeedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryFeedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryFeedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PrimaryFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PrimaryFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PrimaryFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PrimaryFeedback_& instance) = 0;

            protected:
                PrimaryFeedback_DataReader () {};
                ~PrimaryFeedback_DataReader () {};
            private:
                PrimaryFeedback_DataReader (const PrimaryFeedback_DataReader &);
                PrimaryFeedback_DataReader & operator = (const PrimaryFeedback_DataReader &);
            };

            class  PrimaryFeedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PrimaryFeedback_DataReaderView_ptr _ptr_type;
                typedef PrimaryFeedback_DataReaderView_var _var_type;

                static PrimaryFeedback_DataReaderView_ptr _duplicate (PrimaryFeedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PrimaryFeedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PrimaryFeedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PrimaryFeedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PrimaryFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PrimaryFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PrimaryFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PrimaryFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PrimaryFeedback_& instance) = 0;

            protected:
                PrimaryFeedback_DataReaderView () {};
                ~PrimaryFeedback_DataReaderView () {};
            private:
                PrimaryFeedback_DataReaderView (const PrimaryFeedback_DataReaderView &);
                PrimaryFeedback_DataReaderView & operator = (const PrimaryFeedback_DataReaderView &);
            };
        }

    }

}

#endif
